summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorPaul Eggert <eggert@cs.ucla.edu>2011-07-25 13:36:16 -0700
committerPaul Eggert <eggert@cs.ucla.edu>2011-07-25 14:04:51 -0700
commite772bddde8295fe0fdaef05b3c4c5e967116c805 (patch)
treeac24ab8d09068a29a9e1e96556b1254013aff8ea /tests/cp
parentf28a09810b7dc11261cb43e2a09726caf9a993b7 (diff)
downloadcoreutils-e772bddde8295fe0fdaef05b3c4c5e967116c805.tar.xz
cp: don't mishandle existing dir dest permissions (Bug#9170)
* src/copy.c (copy_internal): If we don't create the directory, then we cannot have omitted permissions. Problem and trivial fix reported by Eric Lammerts. * tests/Makefile.am (TESTS): Add cp/existing-perm-dir. * tests/cp/existing-perm-dir: New file.
Diffstat (limited to 'tests/cp')
-rwxr-xr-xtests/cp/existing-perm-dir31
1 files changed, 31 insertions, 0 deletions
diff --git a/tests/cp/existing-perm-dir b/tests/cp/existing-perm-dir
new file mode 100755
index 000000000..6ef73f0a0
--- /dev/null
+++ b/tests/cp/existing-perm-dir
@@ -0,0 +1,31 @@
+#!/bin/sh
+# Make sure cp -p doesn't "restore" permissions it shouldn't (Bug#9170).
+
+# Copyright 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ cp
+
+umask 002
+mkdir -p -m ug-s,u=rwx,g=rwx,o=rx src/dir || fail=1
+mkdir -p -m ug-s,u=rwx,g=,o= dst/dir || fail=1
+
+cp -r src/. dst/ || fail=1
+
+mode=`ls -ld dst/dir | cut -b-10`
+test "$mode" = drwx------ || fail=1
+
+Exit $fail